<template>
  <div class="dashboard">
    <div class="wp-title wp-12">Панель управления</div>
    <div v-if="isUserInvitedInOrganization" class="wp-subtitile wp-12">
      Приглашения
    </div>
    <div v-if="isUserInvitedInOrganization" class="wp-12 infinite_line-container">
      <div class="infinite_line infinite_line--gradient">
        <div v-for="item in invitedOrganizations" :key="item.id"
          class="card card--transparent">
          <div class="card-content">
            <div class="card-content__info">
              <span class="card-content__text">
                {{ item.name }}
              </span>
            </div>
            <div class="card-content__actions">
              <button @click="acceptInvite(item.id)"
                class="card-content__button">
                <font-awesome-icon icon="check" size="sm"/>
              </button>
              <button @click="deleteInvite(item.id)"
                class="card-content__button card-content__button--decline">
                <font-awesome-icon icon="times"/>
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div v-if="isUserInOrganization" class="wp-subtitile wp-12">
      Ваши организации
    </div>
    <div v-if="isUserInOrganization" class="wp-12 infinite_line-container">
      <div class="infinite_line">
        <div v-for="item in organizations" :key="item.id"
          class="card">
          <div class="card-content">
            <div class="card-content__info">
              <span class="card-content__text">
                {{ item.name }}
              </span>
            </div>
            <div class="card-content__actions">
              <button v-if="item.id !== selectedOrganization"
                @click="selectOrganization(item.id)"
                class="card-content__button">
                <font-awesome-icon icon="check" size="sm"/>
              </button>
              <button @click="deleteInvite(item.id, false)"
                class="card-content__button card-content__button--decline">
                <font-awesome-icon icon="sign-out-alt"/>
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapState, mapActions } from 'vuex';

import { parseGraphQLErrors } from '@/graphql/index';
import {
  AcceptOrganizationInvite,
  DeleteOrganizationInvite,
} from '@/graphql/mutations/organizations/invite';

export default {
  name: 'Dashboard',
  computed: {
    ...mapState('session', [
      'accessToken',
      'user',
      'roles',
      'organizations',
      'invitedOrganizations',
      'selectedOrganization',
    ]),
    ...mapGetters('session', ['isUserAdmin', 'isUserInvitedInOrganization', 'isUserInOrganization']),
  },
  methods: {
    ...mapActions('session', ['selectOrganization', 'getAuthorizedUser']),
    acceptInvite(organizationID) {
      this.$apollo.mutate({
        mutation: AcceptOrganizationInvite,
        variables: {
          token: this.accessToken,
          organization_id: organizationID,
        },
      }).then(() => {
        this.getAuthorizedUser();
        this.$toasted.success('Приглашение принято');
      }).catch((resp) => {
        if (resp.graphQLErrors) {
          const errors = parseGraphQLErrors(resp);
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
          return;
        }
        this.$toasted.error(resp);
      });
    },
    deleteInvite(organizationID, isDecline = true) {
      this.$apollo.mutate({
        mutation: DeleteOrganizationInvite,
        variables: {
          token: this.accessToken,
          user_id: this.user.id,
          organization_id: organizationID,
        },
      }).then(() => {
        this.getAuthorizedUser();
        if (isDecline) {
          this.$toasted.success('Приглашение отклонено');
        } else {
          this.$toasted.success('Вы покинули организацию');
        }
      }).catch((resp) => {
        if (resp.graphQLErrors) {
          const errors = parseGraphQLErrors(resp);
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
          return;
        }
        this.$toasted.error(resp);
      });
    },
  },
};
</script>

<style lang="scss" scoped>
.dashboard {

  .infinite_line {
    margin-bottom: 30px;

    &--gradient {
      background: linear-gradient(80deg, $primary 0%, $primaryDark 100%);
    }

    .card {
      position: relative;
      box-sizing: border-box;
      padding: 10px;
      min-width: 350px;
      display: flex;
      flex-direction: column;
      background: #fff;
      border-radius: 5px;

      &:not(:last-child) {
        margin-right: 30px;
      }

      &--transparent {
        color: #fff;
        background: none;
        box-shadow: 0 0 0 17px $neutralLightest;
        background-clip: padding-box;

        .card-header {

          &__icon {
            color: #fff;
          }

        }

        .card-content {

          &__button {
            background: none;
            color: #fff;
            border: 1px solid #fff;

            &:hover {
              background: #fff;
              color: $primary;
            }

            &--decline {

              &:hover {
                color: $secondary;
                border: 1px solid #fff;
              }

            }

          }

        }

      }

      /*&-header {
        height: 24px;
        display: flex;
        justify-content: space-between;
        align-items: center;

        &__info {
          display: flex;
          justify-content: flex-start;
          align-items: center;
        }

        &__indicators {
          display: flex;
          justify-content: flex-end;
        }

        &__icon {
          margin-left: 5px;
          color: $primary;
        }

      }*/

      &-info {

        &::-webkit-scrollbar {
          display: none;
        }

        &__icon {
          margin-right: 5px;
        }

        &__text {
          font-family: $firaSans;
          font-size: 18px;
          font-weight: bold;
        }

      }

      &-content {
        flex: 1;
        display: flex;
        justify-content: space-between;
        align-items: center;

        &__info {
          max-width: 250px;
          display: flex;
          justify-content: flex-start;
          align-items: center;
          overflow-x: scroll;
          scrollbar-width: none;
          -ms-overflow-style: none;

          &::-webkit-scrollbar {
            display: none;
          }

        }

        &__text {
          font-family: $firaSans;
          font-size: 24px;
        }

        &__actions {
          display: flex;
          justify-content: flex-end;
          align-items: center;
        }

        &__button {
          height: 28px;
          width: 28px;
          display: flex;
          justify-content: center;
          align-items: center;
          background: none;
          color: $primary;
          font-family: $firaSans;
          border-radius: 5px;
          border: 1px solid $primary;
          transition: all ease-in-out .2s;

          &:not(:last-child) {
            margin-right: 10px;
          }

          &:hover {
            background: $primary;
            color: #fff;
            cursor: pointer;
          }

          &--decline {

            &:hover {
              background: $secondary;
              border: 1px solid $secondary;
            }

          }

        }

      }

    }

  }

}
</style>
